import _has from "lodash/has";

const selectObjectValueBasedOnState = (object, state, defaultValue) => {
  const {
    status,
    withinThreshold
  } = state;
  const fullStatus = withinThreshold && `${state.status}WithinThreshold`;

  if (fullStatus && _has(object, fullStatus)) {
    return object[fullStatus];
  }

  if (_has(object, status)) {
    return object[status];
  }

  return defaultValue;
};

export default selectObjectValueBasedOnState;