"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = require("react");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _hook = _interopRequireDefault(require("./hook"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const PromiseStatus = ({
  promise,
  thresholdMs,
  onSettleDelayMs,
  onSettle,
  statusMap,
  children
}) => {
  const promiseState = (0, _hook.default)(promise, {
    statusMap,
    thresholdMs,
    onSettle,
    onSettleDelayMs
  });
  const renderedChildren = (0, _react.useMemo)(() => children(promiseState), [children, promiseState]);
  return renderedChildren;
};

PromiseStatus.propTypes = {
  promise: _propTypes.default.object,
  children: _propTypes.default.func.isRequired,
  thresholdMs: _propTypes.default.number,
  onSettleDelayMs: _propTypes.default.oneOfType([_propTypes.default.number, _propTypes.default.object]),
  onSettle: _propTypes.default.func,
  statusMap: _propTypes.default.object
};
var _default = PromiseStatus;
exports.default = _default;
module.exports = exports.default;